using System;
using System.Text;


namespace VaultCmdLineClient
{
	public class Wildcard
	{
		private string strWildcard = null;

		public Wildcard(string str)
		{
			strWildcard = str;
		}

		public string ToRegex(bool bCaseInsensitve)
		{
			StringBuilder strRegex = new StringBuilder();

			if ( strWildcard != null )
			{
				bool bEscape = false, bAlphaChar = false;
				char c, c2;

				strRegex.Append("^");

				for(int j = 0; j < strWildcard.Length; j++)
				{
					c = strWildcard[j];
					switch(c)
					{
						case '*':
						{
							if(bEscape == true)
							{
								strRegex.Append("\\*");
								bEscape = false;
							}
							else
							{
								strRegex.Append(".*");
							}
							break;
						}
						case '.':
						{
							strRegex.Append("\\.");
							bEscape = false;
							break;
						}
						case '?':
						{
							if(bEscape == true)
							{
								strRegex.Append("\\?");
								bEscape = false;
							}
							else
							{
								strRegex.Append('.');
							}
							break;
						}
						case '\\':
						{
							if(bEscape == true)
							{
								strRegex.Append("\\\\");
								bEscape = false;
							}
							else
							{
								bEscape = true;
							}
							break;
						}
						default:
						{
							// since the regex code is based on perl5's, it's likely
							// that any non-letter non-number character means something.
							// so we escape anything non-alphanumeric
							c2 = c;
							if ((c.CompareTo('a') >= 0) && (c.CompareTo('z') <= 0))
							{
								bAlphaChar = true;
								c2 = c2.ToString().ToUpper()[0];
							}
							else if ((c.CompareTo('A') >= 0) && (c.CompareTo('Z') <= 0)) 
							{
								bAlphaChar = true;
								c2 = c2.ToString().ToLower()[0];
							}
							else
							{
								bAlphaChar = false;
							}

							if ( bAlphaChar == true )
							{
								if ( bCaseInsensitve == true )
								{
									strRegex.AppendFormat("[{0}{1}]", c, c2);
								}
								else
								{
									strRegex.Append(c);
								}
							}
							else
							{
								strRegex.AppendFormat("\\{0}", c);
							}

							bEscape = false;
							break;
						}
					}
				}

				strRegex.Append("$");
			}
			return strRegex.ToString();
		}
	}
}